unit HFKNN;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus,
  ErstelleHopfieldNetz, ExtCtrls, StdCtrls, Netz, math, SchwellwertSetzenGUI,
  ComCtrls,
  ImageGUI, ExtDlgs
  ;

type
  THPKNNGUI = class(TForm)
    MainMenu1: TMainMenu;
    DESK1: TMenuItem;
    ber1: TMenuItem;
    N1: TMenuItem;
    Ende1: TMenuItem;
    Men1: TMenuItem;
    ErstelleHopfieldNetz1: TMenuItem;
    Image: TImage;
    ZeigeMatrix1: TMenuItem;
    InitialisereFundamentalmuster1: TMenuItem;
    ZeigeMatrixvonFundamentalmuster1: TMenuItem;
    SetzealsFundamentalmuster1: TMenuItem;
    ZeigeMustervonFundamentalmuster1: TMenuItem;
    Daten1: TMenuItem;
    Anzeige1: TMenuItem;
    N2: TMenuItem;
    SetzeSchwellwertfralleNeuronen1: TMenuItem;
    SetzeSchwellwertfreinNeuron1: TMenuItem;
    N3: TMenuItem;
    LerneGewichteausFundamentalmustern1: TMenuItem;
    N4: TMenuItem;
    ZeigeGewichtsmatrixw1: TMenuItem;
    Propagiere1: TMenuItem;
    N1Schritt1: TMenuItem;
    myStatusBar: TStatusBar;
    N5: TMenuItem;
    BILD1: TMenuItem;
    N6: TMenuItem;
    OPD: TOpenPictureDialog;
    SetzePropagierungsschrittzahl1: TMenuItem;
    N7: TMenuItem;
    procedure Ende1Click(Sender: TObject);
    procedure ErstelleHopfieldNetz1Click(Sender: TObject);
    procedure MakeNet(x,y:Integer);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    function pixToFeldx(pixx: Integer): Integer;
    function pixToFeldy(pixy: Integer): Integer;
    procedure ber1Click(Sender: TObject);
    procedure ZeigeMatrix1Click(Sender: TObject);
    procedure InitialisereFundamentalmuster1Click(Sender: TObject);
    procedure ZeigeMatrixvonFundamentalmuster1Click(Sender: TObject);
    procedure SetzealsFundamentalmuster1Click(Sender: TObject);
    procedure ZeigeMustervonFundamentalmuster1Click(Sender: TObject);
    procedure est1Click(Sender: TObject);
    procedure setzeFeld(x,y,wert:INteger);
    procedure SetzeSchwellwertfralleNeuronen1Click(Sender: TObject);
    procedure SetzeSchwellwertfreinNeuron1Click(Sender: TObject);
    procedure LerneGewichteausFundamentalmustern1Click(Sender: TObject);
    procedure ZeigeGewichtsmatrixw1Click(Sender: TObject);
    procedure Propagiere1Click(Sender: TObject);
    procedure AktMuster;
    procedure N1Schritt1Click(Sender: TObject);
    procedure BILD1Click(Sender: TObject);
    procedure SetzePropagierungsschrittzahl1Click(Sender: TObject);
  private
    FB: Integer;
    myNet: Net;
    erstellt: Boolean;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  HPKNNGUI: THPKNNGUI;

implementation




{$R *.dfm}

procedure THPKNNGUI.Ende1Click(Sender: TObject);
begin
close;
end;

procedure THPKNNGUI.ErstelleHopfieldNetz1Click(Sender: TObject);
var x,y:Integer;
begin
try
ErstelleHopfieldNetzGUI := TErstelleHopfieldNetzGUI.CreateW(addr(x), addr(y), addr(FB),self);
if ErstelleHopfieldNetzGUI.ShowModal=mrOK then
  begin
  MakeNet(x,y);
  end;
except
  Showmessage('Es wurden keine gltigen Werte eingetragen!');
end;
  ErstelleHopfieldNetzGUI.free;
end;

procedure THPKNNGUI.MakeNet(x,y:Integer);
var t:integer;
begin
// liegt noch was im Speicher? Weg damit
  if Erstellt then begin myNet.Destroy; end;
// Fenstergre anpassen
  HPKNNGUI.Width := 600;
  HPKNNGUI.Height :=10;
  HPKNNGUI.AutoSize:=true;
  Image.Create(nil); // unsauber
  Image.Align := alCustom;
  Image.Width := x * FB;
  Image.Height := y * FB;
  myStatusBar.Align:=alBottom;
  HPKNNGUI.AutoSize:=false;
  HPKNNGUI.Height := HPKNNGUI.Height + myStatusBar.Height;

// Netzraster malen
  Image.Canvas.Brush.Color:=clBlack;
  for t:=1 to y do
  begin
    Image.Canvas.MoveTo(0,t*FB);
    Image.Canvas.LineTo(Image.Width,t*FB);
  end;
  for t:=1 to x do
  begin
    Image.Canvas.MoveTo(t*FB,0);
    Image.Canvas.LineTo(t*FB,Image.Height);
  end;
Image.Update;

// Das Netz im Hintergrund erzeugen
myNet:=Net.Create(x,y);

// StatusBar
myStatusBar.Panels.Items[0].Text := 'Neuronen: '+IntToStr(x*y);


myStatusBar.Panels.Items[3].Text := 'Feldgre '+IntToStr(FB);

Erstellt:=true;
end;

procedure THPKNNGUI.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 // Kstchen ausmalen
 if Image.Canvas.Pixels[x,y]= clWhite then
 begin
 Image.Canvas.Brush.Color:=clBlue;
 Image.Canvas.FloodFill(x,y,clBlack,fsBorder);
 myNet.toggle(pixToFeldx(x),pixToFeldy(y));
 end
 else if Image.Canvas.Pixels[x,y]= clBlue then
 begin
 Image.Canvas.Brush.Color:=clWhite;
 Image.Canvas.FloodFill(x,y,clBlack,fsBorder);
 myNet.toggle(pixToFeldx(x),pixToFeldy(y));
 end;
//showmessage( myNet.toString); nicht jedes Mal anzeigen
end;

function THPKNNGUI.pixToFeldx(pixX: Integer): Integer;
begin
setRoundMode(rmUp);
result:=round(pixX/FB);
end;

function THPKNNGUI.pixToFeldy(pixy: Integer): Integer;
begin
setRoundMode(rmUp);
result:=round(pixy/FB);
end;

procedure THPKNNGUI.setzeFeld(x,y,wert:Integer);
begin
  inc(x);inc(y);
  if wert=-1 then
  begin
     Image.Canvas.Brush.Color:=clWhite;
     Image.Canvas.FloodFill(round(x*FB-FB/2),round(y*FB-FB/2),clBlack,fsBorder);
  end;
  if wert= 1 then
  begin
     Image.Canvas.Brush.Color:=clBlue;
     Image.Canvas.FloodFill(round(x*FB-FB/2),round(y*FB-FB/2),clBlack,fsBorder);
  end;

end;


procedure THPKNNGUI.ber1Click(Sender: TObject);
begin
Showmessage('Hopfield Netze Simulator'+#13+#10+'(c) Roman Klinger 2004');
end;

procedure THPKNNGUI.ZeigeMatrix1Click(Sender: TObject);
begin
showmessage(myNet.toString);
end;

procedure THPKNNGUI.InitialisereFundamentalmuster1Click(Sender: TObject);
var x:Integer;
begin
x:=StrToInt(inputbox('Eingabe','Wieviele Fundamentalmuster mchten Sie?',''));
myNet.initFundMuster(x);
// StatusBar
myStatusBar.Panels.Items[1].Text := 'Fund.Muster: 0 - '+IntToStr(myNet.getHighFundMust);
end;

procedure THPKNNGUI.ZeigeMatrixvonFundamentalmuster1Click(Sender: TObject);
var i:Integer;
begin
  i:=StrToInt(inputbox('Eingabe','Welches Fundamentalmuster mchten Sie sehen?',''));
  Showmessage(mynet.FundMusttoString(i));
end;

procedure THPKNNGUI.SetzealsFundamentalmuster1Click(Sender: TObject);
var i:Integer;
begin
  i:=StrToInt(inputbox('Eingabe','Als welches Fundamentalmuster soll das aktuelle Muster gesetzt werden?',''));
  myNet.uebernehmeAlsFundMust(i);
  //Showmessage(mynet.FundMusttoString(i));
end;

procedure THPKNNGUI.ZeigeMustervonFundamentalmuster1Click(Sender: TObject);
var i,a,b:Integer;
begin
  i:=Strtoint(inputbox('Eingabe','Welches Fundamentalmuster mchten Sie sehen?',''));
  for a:=0 to myNet.highx do
    for b:=0 to myNet.highy do
    begin
      setzeFeld(a,b,myNet.getFundMust(i,a,b));
      myNet.FundMusttoAkt(i);
    end;
end;

procedure THPKNNGUI.est1Click(Sender: TObject);
var i,j,k:integer;
begin
  i:=strtoint(inputbox('E','a',''));  j:=strtoint(inputbox('E','b',''));  k:=strtoint(inputbox('E','c',''));
  setzeFeld(i,j,k);
end;

procedure THPKNNGUI.SetzeSchwellwertfralleNeuronen1Click(Sender: TObject);
var wert: Real;
begin
  wert:=StrToFloat(inputbox('Eingabe','Welchen Schwellwert sollen alle Neuronen annehmen?','0'));
  myNet.setTheta(wert);
  myStatusBar.Panels.Items[4].Text := 'Schw.f.a.N: '+FloatToStr(wert);
end;

procedure THPKNNGUI.SetzeSchwellwertfreinNeuron1Click(Sender: TObject);
var
  nr:Integer;
  wert:Real;
begin
try
Schwellwertsetzen := TSchwellwertsetzen.CreateW(addr(nr), addr(wert),self);
if (Schwellwertsetzen.ShowModal=mrOK) then
  begin
  Showmessage('Neuron Nr.: '+inttostr(nr)+' Wert: '+floattostr(wert));
  myNet.setTheta(nr, wert);
  end;
except
  Showmessage('Es wurden keine gltigen Werte eingetragen!');
end;
  Schwellwertsetzen.free;
end;

procedure THPKNNGUI.LerneGewichteausFundamentalmustern1Click(
  Sender: TObject);
begin
myNet.learn;
end;

procedure THPKNNGUI.ZeigeGewichtsmatrixw1Click(Sender: TObject);
begin
Showmessage(myNet.wToString);
end;

procedure THPKNNGUI.Propagiere1Click(Sender: TObject);
begin
randomize;
myNet.Propagiere;
AktMuster;
end;

procedure THPKNNGUI.AktMuster;
var a,b:Integer;
begin
  for a:=0 to myNet.highx do
    for b:=0 to myNet.highy do
    begin
      setzeFeld(a,b,myNet.getAusgabe(a,b));
    end;
end;

procedure THPKNNGUI.N1Schritt1Click(Sender: TObject);
begin
   myNet.PropAlgSchritt;
   AktMuster;
end;

procedure THPKNNGUI.BILD1Click(Sender: TObject);
var i,j,maxX,maxY: Integer;
begin
//  Imageform1.Visible:=true;
// Laden:
if OPD.Execute and (OPD.FileName<>'') then
begin
//Showmessage('Achtung: Laden Sie keine Bilder, welche mehr Pixel haben als das Hopfield-Netz: Es knnte zu Fehlern kommen.');
  ImageForm1.myImage.Picture.LoadFromFile(OPD.FileName);

  maxX:= min(ImageForm1.getwidth, myNet.highx);
  maxY:= min(ImageForm1.getheigt, myNet.highy);
  for i:=0 to maxX do
    for j:=0 to maxY do
    begin
      myNet.setField(i,j,ImageForm1.getpix(i,j));
    end;
  AktMuster;
end;
end;

procedure THPKNNGUI.SetzePropagierungsschrittzahl1Click(Sender: TObject);
begin
myNet.setAnzahlpropagierungsschritte(strtoint(inputbox('Eingabe','Wie viele Schritte sollen bei der Propagierung durchgefhrt werden? (Die Eingabe wird noch mit der Neuronenanzahl multipliziert.','10')));
myStatusBar.Panels.Items[2].Text := 'Prop.Schritte: '+IntToStr(myNet.getAnzahlpropagierungsschritte)+' * NA';
end;

end.
