unit ImageGUI;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TImageForm1 = class(TForm)
    myImage: TImage;
    procedure Button1Click(Sender: TObject);
    procedure myImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function getwidth:Integer;
    function getheigt:Integer;
    function getpix(x,y:INteger):Integer;
  end;

var
  ImageForm1: TImageForm1;

implementation

{$R *.dfm}

procedure TImageForm1.Button1Click(Sender: TObject);
var i,j:Integer;
begin
  for i:=1 to myImage.Width-1 do
    for j:=1 to myImage.Height-1 do
    begin
      ImageForm1.Color := myImage.Picture.Bitmap.Canvas.Pixels[i,j];
    end;
end;

procedure TImageForm1.myImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  ImageForm1.Color := myImage.Picture.Bitmap.Canvas.Pixels[X,Y];
end;

function TImageForm1.getwidth:Integer;
begin
result:=myImage.Width-1;
end;

function TImageForm1.getheigt:Integer;
begin
result:=myImage.Height-1;
end;

function TImageForm1.getpix(x,y:Integer):Integer;
begin
if ColorToRGB(myImage.Picture.Bitmap.Canvas.Pixels[x,y]) = 0 then result:=1
else result:=-1;
end;

end.
